package de.laliluna.tutorial.multipageform.form;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

/**
 * ActionForm class ExampleForm
 */
public class ExampleForm extends ActionForm {

	// properties
	String name;
	Integer age;
	String city;
	String phone;

	public Integer getAge() {
		return age;
	}

	public void setAge(Integer age) {
		this.age = age;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getPhone() {
		return phone;
	}

	public void setPhone(String phone) {
		this.phone = phone;
	}

	/**
	 * Method validate
	 * 
	 * @param mapping
	 * @param request
	 * @return ActionErrors
	 */
	public ActionErrors validate(ActionMapping mapping,
			HttpServletRequest request) {

		ActionErrors actionErrors = new ActionErrors();

		// get the hidden field to identify which
		// validation will be execute
		String step = request.getParameter("step");

		if (step != null) {
			// validation for step 1
			if (step.equals("1")) {

				// name must have at least 3 characters
				if (this.name.length() < 3) {
					actionErrors.add("name", new ActionMessage("error.name"));
				}

				// age must be between 18 - 90
				if (age == null || age < 18 || age > 90) {
					actionErrors.add("age", new ActionMessage("error.age"));
				}
			}

			// vaidation for step 2
			if (step.equals("2")) {

				// city must have at least 2 characters
				if (this.city.length() < 2) {
					actionErrors.add("city", new ActionMessage("error.city"));
				}

				// phone must have at least 5 characters
				if (this.phone.length() < 5) {
					actionErrors.add("phone", new ActionMessage("error.phone"));
				}
			}
		}

		return actionErrors;
	}
}
